﻿//------------------------------------------------------------------------------
//
// Sample class for AS2Unit
//
// Alistair McLeod
// amcleod@iterationtwo.co.uk
//
// (c) 2003 iteration::two Ltd
//
//------------------------------------------------------------------------------

class com.iterationtwo.Money
{
	public function Money( pounds:Number, pence:Number )
	{
		if ( pounds == undefined || pence == undefined )
			throw new Error( "Invalid constructor arguments" );

		if ( pence > 100 )
		{
		   pounds = pounds + Math.floor( pence / 100 );
			pence = pence % 100;
		}

		this.pounds = pounds;
		this.pence = pence;
	}

//------------------------------------------------------------------------------

	public function addMoney( money:Money ):Money
	{
		var pounds:Number = this.pounds;
		var pence:Number = this.pence;

		pounds = pounds + money.pounds;
		pence = pence + money.pence;

		return flatten( pounds, pence );
	}

//------------------------------------------------------------------------------

	public function subtractMoney( money:Money ):Money
	{
		var pounds:Number = this.pounds;
		var pence:Number = this.pence;

		pounds = pounds - money.pounds;

		pence = pence - money.pence;

		money = flatten( pounds, pence );

		if ( money.pounds < 0 || money.pence < 0 )
			throw new Error( "Illegal subtraction resulted in " + money.pounds + " pounds and " + money.pence + " pence" );

		return money;
	}

//------------------------------------------------------------------------------

	public function greaterThan( money:Money ):Boolean
	{
		var flattened:Money = flatten( money.pounds, money.pence );

		return toPence() > flattened.toPence();
	}

//------------------------------------------------------------------------------

	public function lessThan( money:Money ):Boolean
	{
		var flattened:Money = flatten( money.pounds, money.pence );

		return toPence() < flattened.toPence();
	}

//------------------------------------------------------------------------------

	public function equals( money:Money ):Boolean
	{
		var flattened:Money = flatten( money.pounds, money.pence );

		return toPence() == flattened.toPence();
	}

//------------------------------------------------------------------------------

	private function toPence():Number
	{
		return pounds * 100 + pence;
	}

//------------------------------------------------------------------------------

	private function flatten( pounds:Number, pence:Number ):Money
	{
		if ( pence > 100 )
		{
		   pounds = pounds + Math.floor( pence / 100 );
			pence = pence % 100;
		}

		if ( pence < 0 )
		{
		   pounds = pounds + Math.floor( pence / 100 );
			pence = ( pence % 100 ) + 100 ;
		}

		return new Money( pounds, pence );
	}

//------------------------------------------------------------------------------

	public function get pounds():Number
	{
		return __pounds;
	}

//------------------------------------------------------------------------------

	public function set pounds( pounds:Number ):Void
	{
		__pounds = pounds;
	}

//------------------------------------------------------------------------------

	public function get pence():Number
	{
		return __pence;
	}

//------------------------------------------------------------------------------

	public function set pence( pence:Number ):Void
	{
		__pence = pence;
	}

//------------------------------------------------------------------------------

	private var __pounds:Number;
	private var __pence:Number
}